
% 1. Write a 3-place predicate combine1 which takes three lists as arguments
% and combines the elements of the first two lists into the third as follows:
% ?- combine1([a,b,c],[1,2,3],X).
%          X = [a,1,b,2,c,3]
% ?- combine1([foo,bar,yip,yup],[glub,glab,glib,glob],Result).
% Result = [foo,glub,bar,glab,yip,glib,yup,glob]

combine1([],[],[]).
combine1([H1|T1],[H2|T2],[H1,H2|T]) :- combine1(T1,T2,T).


% 2. Now write a 3-place predicate combine2 which takes three lists as
% arguments and combines the elements of the first two lists into the third
% as follows:
% ?- combine2([a,b,c],[1,2,3],X).
% X = [[a,1],[b,2],[c,3]]
% ?- combine2([foo,bar,yip,yup],[glub,glab,glib,glob],Result).
% Result = [[foo,glub],[bar,glab],[yip,glib],[yup,glob]]

combine2([],[],[]).
combine2([H1|T1],[H2|T2],[[H1,H2]|T]) :- combine2(T1,T2,T).


% 3. Finally, write a 3-place predicate combine3 which takes three lists
% as arguments and combines the elements of the first two lists into the
% third as follows:
% ?- combine3([a,b,c],[1,2,3],X).
% X = [join(a,1),join(b,2),join(c,3)]
% ?- combine3([foo,bar,yip,yup],[glub,glab,glib,glob],R).
% R = [join(foo,glub),join(bar,glab),join(yip,glib),...

combine3([],[],[]).
combine3([H1|T1],[H2|T2],[join(H1,H2)|T]) :- combine3(T1,T2,T).
